> ## Documentation Index
> Fetch the complete documentation index at: https://developer.copper.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Get ClearLoop Actions



## OpenAPI

````yaml /copper-open-api-public.json get /clearloop/actions
openapi: 3.1.0
info:
  description: >-
    Copper API is based on the REST API interface provided for data exchange
    between a client and a server with the use of HTTPS requests and responses.

    By default, the request should include a Content-Type header set as
    application/json. Some requests require different header fields, as well as
    other Content-Type values. In this case, a proper header will be stated in
    an example.

    When interacting with the API, please note that all numerical values, such
    as order amounts or timestamps, should be transmitted as strings. This
    ensures consistent data representation and prevents potential issues with
    floating-point precision
  title: Copper Platform API
  version: latest
servers:
  - description: platform.copper.co
    url: https://api.copper.co/platform
  - description: demo.copper.co
    url: https://api.stage.copper.co/platform
  - description: testnet.copper.co
    url: https://api.testnet.copper.co/platform
security: []
tags:
  - name: reports
  - name: deposit-targets
  - name: lending
  - name: portfolios
  - name: wallets
  - name: network
  - name: stake
  - name: blockchain
  - name: organizations
  - name: files
  - name: orders
  - name: address-book
  - name: clearloop
  - name: currencies
paths:
  /clearloop/actions:
    get:
      tags:
        - clearloop
      summary: Get ClearLoop Actions
      parameters:
        - description: >-
            Unix timestamp (in milliseconds) to retrieve records from this point
            in time
          in: query
          name: fromTimestamp
          required: false
          schema:
            type: string
        - description: >-
            Unix timestamp (in milliseconds) to retrieve records up to this
            point in time
          in: query
          name: toTimestamp
          required: false
          schema:
            type: string
        - description: >-
            Unique identifier of the exchange account for which records are
            retrieved
          in: query
          name: clientAccountId
          required: false
          schema:
            type: string
        - description: List of Copper portfolio IDs to filter records
          in: query
          name: portfolioIds
          required: false
          schema:
            items:
              type: string
            type: array
        - description: >-
            Type of action: `add-funds` (delegate to the exchange) or
            `remove-funds` (undelegate from the exchange)
          in: query
          name: actionType
          required: false
          schema:
            type: string
        - description: Maximum number of records to return (pagination limit)
          in: query
          name: limit
          required: false
          schema:
            type: string
        - description: >-
            Number of records to skip before starting to return results
            (pagination offset)
          in: query
          name: offset
          required: false
          schema:
            type: string
        - description: 'Sort order for results: `asc` for ascending or `desc` for descending'
          in: query
          name: sortDirection
          required: false
          schema:
            default: asc
            type: string
        - description: >-
            If true, only return records for actions that have been successfully
            executed (i.e., funds have been successfully added or removed).If
            false, include all records regardless of execution status
          in: query
          name: filterExecuted
          required: false
          schema:
            default: 'false'
            type: boolean
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetActionsResponse'
          description: OK
        '400':
          content:
            application/json:
              schema:
                properties:
                  error:
                    description: The machine-readable error code
                    examples:
                      - bad-request
                    type: string
                  message:
                    description: >-
                      A human-readable message providing more details about the
                      error
                    type: string
                type: object
          description: Bad Request
        '403':
          content:
            application/json:
              schema:
                properties:
                  error:
                    description: The machine-readable error code
                    examples:
                      - forbidden
                    type: string
                  message:
                    description: >-
                      A human-readable message providing more details about the
                      error
                    type: string
                type: object
          description: Forbidden
        '409':
          content:
            application/json:
              schema:
                properties:
                  error:
                    description: The machine-readable error code
                    examples:
                      - conflict
                    type: string
                  message:
                    description: >-
                      A human-readable message providing more details about the
                      error
                    type: string
                type: object
          description: Conflict
components:
  schemas:
    GetActionsResponse:
      properties:
        actions:
          description: >-
            Wrapper containing an array of delegation and undelegation action
            records
          items:
            $ref: '#/components/schemas/ClearLoopAction'
          type: array
        pagination:
          $ref: '#/components/schemas/ClearLoopPagination'
          description: Object containing pagination-related info
          type: object
      required:
        - actions
      type: object
    ClearLoopAction:
      properties:
        action:
          description: >-
            Type of action performed: `add-funds` (delegate) or `remove-funds`
            (undelegate)
          type: string
        amount:
          description: Amount of funds involved in the action
          type: string
        clearLoopPortfolioId:
          description: ClearLoop portfolioId
          type: string
        clientAccountId:
          description: Unique identifier of the client’s exchange account
          type: string
        completedAt:
          description: Unix timestamp (in milliseconds) when the action was completed
          type: string
        createdAt:
          description: Unix timestamp (in milliseconds) when the action was initiated
          type: string
        currency:
          description: Currency in which the action was performed
          type: string
        delegatedOrganizationId:
          description: >-
            Identifier of the organisation on the exchange to which the balance
            is delegated
          type: string
        exchangeId:
          description: Identifier of the exchange where the delegated balance is held
          type: string
        network:
          description: Network used for the currency
          type: string
        orderId:
          description: Unique identifier of the order associated with the action
          type: string
        organizationId:
          description: Identifier of the client organisation initiating the action
          type: string
        status:
          description: Status of the action (e.g. `executed`)
          type: string
        updatedAt:
          description: Unix timestamp (in milliseconds) when the action was last updated
          type: string
        usdAmount:
          description: USD equivalent of the `amount` at the time of execution
          type: string
      required:
        - delegatedOrganizationId
        - organizationId
        - clientAccountId
        - action
        - currency
        - amount
        - createdAt
      type: object
    ClearLoopPagination:
      properties:
        limit:
          description: Numerical limit of records for any given page
          type: string
        page:
          description: Current page index (numerical)
          type: string
        pages:
          description: Total number of pages matching the query
          type: string
        totalItems:
          description: Total number of records returned
          type: string
      type: object

````